﻿#pragma once

#include <wrl\client.h>
#include <windows.ui.input.h>
#include <RadialControllerInterop.h>

class MyRadialListner
{
public:

	MyRadialListner();
	~MyRadialListner() {}

	HRESULT Init(HWND hwnd);
	HRESULT SetRotationResolutionInDegrees(double res);
	HRESULT GetRotationResolutionInDegrees(double& res);
	HRESULT SetUseAutomaticHapticFeedback(bool use);
	HRESULT GetUseAutomaticHapticFeedback(bool& use);

private:

	HWND m_hwnd;

	HRESULT PopulateMenuItems();
	HRESULT AddMenuItemFromIcon(_In_ HSTRING itemName, _In_ ABI::Windows::Storage::Streams::IRandomAccessStreamReference *icon, _In_ EventRegistrationToken registrationToken);
	HRESULT AddMenuItemFromKnownIcon(_In_ HSTRING itemName, _In_ ABI::Windows::UI::Input::RadialControllerMenuKnownIcon icon, _In_ EventRegistrationToken registrationToken);
	HRESULT AddMenuItemFromSystemFont(_In_ HSTRING itemName, _In_ HSTRING fontName, _In_ HSTRING itemGlyph, _In_ EventRegistrationToken registrationToken);
	HRESULT AddMenuItem(_In_ Microsoft::WRL::ComPtr<ABI::Windows::UI::Input::IRadialControllerMenuItem> item, _In_ HSTRING itemName, _In_ EventRegistrationToken registrationToken);
	HRESULT OnItemInvoked(_In_ ABI::Windows::UI::Input::IRadialControllerMenuItem* item, _In_ IInspectable* args);

	HRESULT OnScreenContactStarted(_In_ ABI::Windows::UI::Input::IRadialController*, _In_ ABI::Windows::UI::Input::IRadialControllerScreenContactStartedEventArgs* args);
	HRESULT OnScreenContactContinued(_In_ ABI::Windows::UI::Input::IRadialController*, _In_ ABI::Windows::UI::Input::IRadialControllerScreenContactContinuedEventArgs* args);
	HRESULT OnScreenContactEnded(_In_ ABI::Windows::UI::Input::IRadialController* sender, _In_ IInspectable* args);
	HRESULT OnControlLost(_In_ ABI::Windows::UI::Input::IRadialController* sender, _In_ IInspectable* args);
	HRESULT OnControlAcquired(_In_ ABI::Windows::UI::Input::IRadialController* sender, _In_ ABI::Windows::UI::Input::IRadialControllerControlAcquiredEventArgs* args);
	HRESULT OnRotationChanged(_In_ ABI::Windows::UI::Input::IRadialController* sender, _In_ ABI::Windows::UI::Input::IRadialControllerRotationChangedEventArgs* args);

	template<typename TContactArgs>
	HRESULT LogContact(_In_ TContactArgs* args);
	void PrintMsg(WCHAR *message, WORD messageColor);

	HANDLE _console = nullptr;
	CONSOLE_SCREEN_BUFFER_INFO _screenBuf = {};

	Microsoft::WRL::ComPtr<ABI::Windows::UI::Input::IRadialController> _controller;
	Microsoft::WRL::ComPtr<ABI::Windows::UI::Input::IRadialControllerMenu> _menu;
	Microsoft::WRL::ComPtr<ABI::Windows::UI::Input::IRadialControllerMenuItemStatics> _menuItemStatics;

	EventRegistrationToken _rotatedToken;
	EventRegistrationToken _screenContactStartedToken;
	EventRegistrationToken _screenContactEndedToken;
	EventRegistrationToken _screenContactContinuedToken;
	EventRegistrationToken _controlLostToken;
	EventRegistrationToken _controlAcquiredToken;
	EventRegistrationToken _buttonClickedToken;
	EventRegistrationToken _knownIconItem1Token;
	EventRegistrationToken _knownIconItem2Token;
	EventRegistrationToken _knownIconItem3Token;
	EventRegistrationToken _systemFontItemToken;
	EventRegistrationToken _customFontItemToken;
};
