﻿#include "stdafx.h"
#include "listener.h"

// メインウィンドウプロシージャ
LRESULT CALLBACK WindowProc(__in HWND hWindow, __in UINT uMsg, __in WPARAM wParam, __in LPARAM lParam)
{
	switch(uMsg)
	{
	case WM_CLOSE:

		DestroyWindow(hWindow);
		return 0;

	case WM_DESTROY:

		PostQuitMessage(0);
		return 0;
	}

	return DefWindowProc(hWindow, uMsg, wParam, lParam);
}

// アプリメイン処理
int AppMainProc()
{
	// ウィンドウクラスの登録
	WNDCLASSEX wndClass = {};
	wndClass.cbSize = sizeof(wndClass);
	wndClass.style = CS_DBLCLKS;
	wndClass.lpfnWndProc = (WNDPROC)WindowProc;
	wndClass.hInstance = GetModuleHandle(NULL);
	wndClass.hCursor = LoadCursor(NULL, IDC_ARROW);
	wndClass.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
	wndClass.lpszClassName = L"RadialControllerTestApp";
	auto regclass = RegisterClassEx(&wndClass);
	if(!regclass)
	{
		return -2;
	}

	// メインウィンドウ作成
	HWND hwnd = CreateWindow(MAKEINTATOM(regclass), L"Message Listener Window",
		WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
		NULL, NULL, NULL, NULL);
	if(!hwnd)
	{
		return -3;
	}
	ShowWindow(hwnd, SW_SHOWDEFAULT);
	UpdateWindow(hwnd);

	// コントロール入力受付クラスを生成して初期化
	std::unique_ptr<MyRadialListner> listener(new MyRadialListner());
	HRESULT hr = listener->Init(hwnd);
	if(FAILED(hr))
	{
		return -4;
	}

	// メッセージループ
	MSG msg;
	while(GetMessage(&msg, NULL, 0, 0))
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return (int)msg.wParam;
}

// エントリーポイント
int wmain(int argc, WCHAR *argv[])
{
	// WinRTの初期化
	if(FAILED(Windows::Foundation::Initialize(RO_INIT_MULTITHREADED)))
	{
		return -1;
	}

	int ret = AppMainProc();

	// WinRTの使用終了
	Windows::Foundation::Uninitialize();

	return ret;
}
